/* $XConsortium: ctag.h /main/2 1996/12/30 16:29:32 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

// ctag.h
//
// A collectable tag
//

#ifndef _CTAG_H
#define _CTAG_H

#include "xadefines.h"
#include "collectable.h"
#include <Xa/atomdefs.h>

class XaCTag : public XaCollectable {

public:
    XaCTag(XaTag t) : theTag(t) {}
    XaCTag() : theTag(XaTnone) {}
    virtual ~XaCTag() {}

    // Cast one of these guys to a Tag to get "the tag".
    inline virtual operator XaTag() const { return theTag;}

    // Better not be comparing against non tag collectables.
    inline virtual XaBoolean equals(const XaCollectable &o) const {
	return ((XaCTag&)o).theTag == theTag;
    }

    inline virtual unsigned hash(void) const { return theTag; }

private:
    XaTag theTag;
};

#endif
