/* $XConsortium: filedefs.h /main/2 1996/12/30 16:29:44 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

/* Copyright (c) 1992 by Sun Microsystems, Inc. */

#ifndef _FILEDEFS_H
#define	_FILEDEFS_H


/* Struct to store
 * Sun audio header values.
 */
typedef struct {
        unsigned        sample_rate;            /* samples per second */
        unsigned        samples_per_unit;       /* samples per unit */
        unsigned        bytes_per_unit;         /* bytes per sample unit */
        unsigned        channels;               /* # of interleaved channels */
        unsigned        encoding;               /* data encoding format */
        unsigned        endian;                 /* byte order */
        unsigned        data_size;              /* length of data (optional) */
        unsigned        hdr_size;               /* header size */
} Audio_hdr;

#if defined (mc68000) || defined (sparc)
#define	DECODE_LONG(from, to)	*((long *)(to)) = *((long *)(from))
#endif /*big-endian*/

#if defined (i386) || defined (__ppc)
#define	DECODE_LONG(from, to)						\
			    ((char *)(to))[0] = ((char *)(from))[3];	\
			    ((char *)(to))[1] = ((char *)(from))[2];	\
			    ((char *)(to))[2] = ((char *)(from))[1];	\
			    ((char *)(to))[3] = ((char *)(from))[0];
#endif /*little-endian*/

#endif /* !_FILEDEFS_H */
