/* $XConsortium: cobject.h /main/3 1996/12/30 16:30:20 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

/*
Copyright (c) 1996 Digital Equipment Corporation

Digital Equipment Corporation makes no representations about
the suitability of this Software for any purpose.  The Software
is provided "as is" without express or implied warranty.


@SUN_COPYRIGHT@

*/
#ifndef __cobject_h
#define __cobject_h

#include <X11/Xmd.h>
#include <sys/types.h>
#include <Xa/Xalib.h>

_XAFUNCPROTOBEGIN

typedef struct {
    XaTag name;          /* Attribute Name Tag  */
    XaTag type;          /* Attribute Type Tag  */
    void *value;         /* The current value of attribute  */
    void *newValue;      /* The "new" value in a Set/Validate/Check call.*/
} XaAttributeCBData;

typedef void (*XaAttributeSetCB)(void *, XaAttributeCBData *);
typedef void (*XaAttributeGetCB)(void *, XaAttributeCBData *);
typedef XaBoolean (*XaAttributeCheckCB)(void *, XaAttributeCBData *);
typedef XaBoolean (*XaAttributeValidateCB)(void *, int, XaAttributeCBData **);

void SetAttributeSetCB (void              *object,
			XaAttributeCBData *data,
			XaAttributeSetCB   mySetCB);


void SetAttributeGetCB (void              *object,
			XaAttributeCBData *data,
			XaAttributeGetCB   myGetCB);

void SetAttributeCheckCB (void                *object,
			  XaAttributeCBData   *data,
			  XaAttributeCheckCB   myCheckCB);


void SetAttributeValidateCB (void                   *object,
			     XaAttributeValidateCB   myValidateCB);


_XAFUNCPROTOEND

#endif
