/* $XConsortium: condition.h /main/3 1996/12/30 16:30:26 swick $ */
/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/
/*
Copyright (c) 1996  The Santa Cruz Operation, Inc.

The X Consortium, and any party obtaining a copy of these files
from the X Consortium, directly or indirectly, is granted, free
of charge, a full and unrestricted irrevocable, world-wide,
paid up, royalty-free, nonexclusive right and license to deal in this
software and documentation files (the "Software"), including
without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicence, and sell copies of the Software, and to
permit persons who receive copies from any such party to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

SCO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
IN NO EVENT SHALL SCO BE LIABLE FOR ANY SPECIAL, INDIRECT,
PUNITIVE, CONSEQUENTIAL OR INCIDENTAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, LOSS OF DATA OR LOSS OF
PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
*/

//
// XaCondition tests for changes in an object.
//

#ifndef __condition_h
#define __condition_h

#include "Xalib.h"
#include "object.h"
#include "pointer.h"

class XaCondition : public XaObject
{
  public:
    XaCondition(XaConnection *c, XaClass *cl, XaTag objectTag, XaTag classID,
	XaTag name);

    ~XaCondition();

    XaBoolean Evaluate(XaAttributeCBData *attr);

  private:
    XaAtom attribute;
    XaAtom comparison;
    BOOL onTransition;
    CARD32 reference;	// XXX XaPointer?
    CARD32 delta;	// XXX XaPointer?
    BOOL lastEvaluation;
};

#endif // __condition_h
