/* $XConsortium: read.cc /main/5 1996/12/30 16:31:19 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

/*
Copyright (c) 1996 Digital Equipment Corporation

Digital Equipment Corporation makes no representations about
the suitability of this Software for any purpose.  The Software
is provided "as is" without express or implied warranty.


@SUN_COPYRIGHT@

*/

// 
// Copyright (c) 1996 Digital Equipment Corporation
// 
// Digital Equipment Corporation makes no representations about
// the suitability of this Software for any purpose.  The Software
// is provided "as is" without express or implied warranty.
//
// HISTORY
// 
// @(#)$RCSfile: read.cc $ $Revision: /main/5 $ (DEC) $Date: 1996/12/30 16:31:19 $
// 
#include <Xa/Xalib.h>
#include <Xa/Xaprotocol.h>
#include "serverconn.h"
#include "buffer.h"
#include "intbuffer.h"

void XaRead(XaAudio connection, XaTag port,
            XaTime atTime, XaTag referenceTime,
            Card32 minBits, Card32 maxBits,
            char **buff, Card32 *nBitsReturned, Int8 *leftPad,
            XaFinish *finish)
{
    XaServerConnection *conn = (XaServerConnection *)connection;
//
// Check if this object is in the client object database.
//
    XaObject *obj = (XaObject *)conn->ObjectDB().find(port);
//
// Initialize bits returned value
//
    *nBitsReturned = 0;
//
// If it is, then read from object on client side.
//
    if (obj) {
      //if (obj->IsReadable()) { 
        XaBuffer     *buffer = (XaBuffer *)obj;
        CARD32        nBitsRead;
	XaTime deviceTime;
        XaErrorCode   err;
        XaInternalBuffer *ibuffer =
	    new XaInternalBuffer ((maxBits / 8), *buff);
	
        err = buffer->Read(atTime, referenceTime,
			   ibuffer, maxBits, *(CARD8 *)leftPad, 
			   nBitsRead, deviceTime);
	
        if (err != XaESuccess)
	    *nBitsReturned = 0;
        else
	    *nBitsReturned = (Card32)nBitsRead;

        ibuffer->Release();
	if (finish)
          finish->finishProc(finish->clientData);

      //} 
    }
//
// otherwise, send the message to the server.
//
    else

      ((XaServerConnection *)connection)->read(port,
				atTime, referenceTime,
				minBits, maxBits, 
				buff, nBitsReturned, leftPad,
				finish);
}

void XaServerConnection::read(XaTag port,
			XaTime atTime, XaTag referenceTime,
			Card32 minBits, Card32 maxBits,
			char **buff, Card32 *bitsReturned, Int8 *leftPad,
			XaFinish *finish)
{
    XaReadRequest req;
    XaProtoReply *protoReply;
    XaAudioDataReply *reply;

    req.minorOpcode = READ;
    req.object = port;
    req.when = atTime;
    req.time_ref = referenceTime;
    req.min_bits = minBits;
    req.max_bits = maxBits;


    *buff = (char *)sendMessage((XaProtoHeader *)&req, 0, NULL, finish,
				protoReply);

    // Get the reply
    // fill in the buff and bitsReturned and leftPad params.
    reply = (XaAudioDataReply *)protoReply;

    *bitsReturned = reply->numBits;
    *leftPad = reply->leftPad;
}
