/* $XConsortium: key_test.cc /main/2 1996/12/30 16:35:31 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

/* Test key class from within server */

#include "class.h"

static void KeyTest(XaConnection *conn);

#define TEST_POINT KeyTest(conn)

#include "classes.cc"

static void KeyTest(XaConnection *conn)
{
    XaErrorCode ecode = XaESuccess;
    XaTag          dummyObjTag = 0x4001;        /*XXX*/
    XaTag          dummyNameTag = 1024;        /*XXX*/

    printf("Creating Key...\n");
    XaObject *key = XaCreateObject(conn, XaTkey, dummyObjTag, dummyNameTag, 
	    NULL, 0);
    printf("	%s!\n", (key) ? "passed" : "failed" );

    printf("Setting active attribute to false\n");
    ecode = key->SetAttribute(conn, XaAkeyActive, (void *)XaFalse);
    printf("	%s! - %d\n", ((ecode == XaESuccess) ? "passed" : "failed"),
	    ecode);

    void *v;
    printf("Getting active attribute\n");
    ecode = key->GetAttribute(conn, XaAkeyActive, v);
    printf("	%s! - %d\n", ((ecode == XaESuccess && !(XaBoolean)v) ? 
	    "passed" : "failed"), ecode);

    printf("Destroying object...\n");
    delete key;
    printf("	... destroyed\n");
}
