/* $XConsortium: test.cc /main/2 1996/12/30 16:35:48 swick $ */

/*
Copyright (c) 1996  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.
*/

// 
// Copyright (c) 1996 Digital Equipment Corporation
// 
// Digital Equipment Corporation makes no representations about
// the suitability of this Software for any purpose.  The Software
// is provided "as is" without express or implied warranty.
//
// HISTORY
// 
// @(#)$RCSfile: test.cc $ $Revision: /main/2 $ (DEC) $Date: 1996/12/30 16:35:48 $
// 
#include <stdlib.h>
#include "connection.h"
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <Xa/Xaprotocol.h>




main (int argc, char* argv[])
{
    char *networkId = NULL;
    XaServerConnection *conn;
    
    if (argc > 1)
	networkId = argv[1];
    
    fprintf(stderr,"Creating connection.\n");
    conn = new XaServerConnection;
    
    if (!conn->open(networkId))
    {
	fprintf(stderr,"Couldn't open connection.\n");
	exit(1);
    }
    
    fprintf(stderr,"Pinging server.\n");
    // conn->sendMessage(42, 0, NULL, 0, NULL, NULL);

    conn->pingServer();
    conn->pingServer();

    {
    XaFindRequest  req;
    req.minorOpcode = FIND;
    char name[] = "my BS name for the FIND request";

    conn->sendMessage((XaProtoHeader *)&req, sizeof(name), name, 
			NULL);


    }

    XaGetRequest req;
    TAG retAttr[3];

    req.minorOpcode = GET;
    req.object = 666;
    req.trigger = 333;
    req.n_attributes = 3;
    retAttr[0] = 1;
    retAttr[1] = 2;
    retAttr[2] = 3;


    conn->sendMessage((XaProtoHeader *)&req, sizeof(retAttr), (char *)retAttr, 
			NULL);

    conn->pingServer();
    conn->pingServer();
    
    fprintf(stderr,"Running connection main loop.\n");
    conn->mainLoop();
    //sleep(90);
    //exit(1);
}
